Subject: bug#70409: 30.0.50; `latexenc-find-file-coding-system` uses `TeX-master` before we know it's safe

From: Eli Zaretskii <[email-masked]>
Date: Tue, 16 Apr 2024 14:49:02 +0300

> Cc: [email-masked]
> Date: Mon, 15 Apr 2024 18:42:36 -0400
> From:  Stefan Monnier via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> If I open a file `foo.tex` with a local variable setting of
> `TeX-master: "paper.tex"` and that `paper.tex` file has a local
> variable setting of `TeX-master: t`, I get the funny behavior that
> Emacs first asks me whether to obey the `TeX-master: t` setting of
> `paper.tex` before asking me whether to obey the `TeX-master:
> "paper.tex"` setting of `foo.tex`, even though it obviously had to use
> the `TeX-master: "paper.tex"` setting in order to decide to open the
> `paper.tex` file (and ask me about its `TeX-master: t`).
> 
> The corresponding backtrace looks as below:
> 
>     Debugger entered--Lisp error: (minibuffer-quit)
>       #<subr F616e6f6e796d6f75732d6c616d626461_anonymous_lambda_57>()
>       read-char-from-minibuffer("Please type y, n, ! or i, or C-v/M-v to scroll: " (33 105 121 110 32))
>       read-char-choice("Please type y, n, ! or i, or C-v/M-v to scroll: " (33 105 121 110 32))
>       hack-local-variables-confirm(((TeX-master . t)) ((TeX-master . t)) nil nil)
>       hack-local-variables-filter(((TeX-master . t)) nil)
>       hack-local-variables(no-mode)
>       run-mode-hooks(latex-mode-hook)
>       latex-mode()
>       set-auto-mode-0(latex-mode nil)
>       set-auto-mode()
>       normal-mode(t)
>       after-find-file(nil nil)
>       find-file-noselect-1(#<buffer paper.tex> ".../paper.tex" t nil ".../paper.tex" (3064599 65026))
>       find-file-noselect("paper.tex" t)
>       latexenc-find-file-coding-system((insert-file-contents ".../foo.tex" t nil nil nil))
>       insert-file-contents(".../foo.tex" t)
>       find-file-noselect-1(#<buffer foo.tex> ".../foo.tex" nil nil ".../foo.tex" (3064581 65026))
>       find-file-noselect(".../foo.tex")
>       command-line-1((".../foo.tex"))
>       command-line()
>       normal-top-level()
> 
> showing that the problem is that `latexenc-find-file-coding-system`
> is the function that opens `paper.tex` before the users had a chance to
> confirm that they think this is safe.

Is it correct for latexenc-find-file-coding-system to use
find-file-noselect for this purpose?  Why does it call
insert-file-contents with 2nd arg non-nil, if all it needs is to find
and process the encoding spec there?

Alternatively, we could disable local-variable processing when calling
latexenc-find-file-coding-system.  WDYT?

> I suggest the patch below which makes `latexenc-find-file-coding-system`
> use `safe-local-variable-p` before using a file-local setting, and also
> adds corresponding `safe-local-variable` settings for `TeX-master` and
> `tex-main-file`.

Is it really guaranteed that safe local variables will never cause
similar problems?  That they are safe doesn't mean they must be
processed at this point.